org.apache.hc.core5.http.nio.support

## Class ImmediateResponseExchangeHandler

- java.lang.Object
- - org.apache.hc.core5.http.nio.support.ImmediateResponseExchangeHandler

- All Implemented Interfaces:
    AsyncDataConsumer, AsyncDataExchangeHandler, AsyncDataProducer, AsyncServerExchangeHandler, ResourceHolder

      public final class ImmediateResponseExchangeHandler
      extends Object
      implements AsyncServerExchangeHandler

  `AsyncServerExchangeHandler` implementation that immediately responds with a predefined response generated by a `AsyncResponseProducer` and ignores any entity content enclosed in the request message.
  Since:
    5.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ImmediateResponseExchangeHandler(AsyncResponseProducer responseProducer)`
    `ImmediateResponseExchangeHandler(HttpResponse response, String message)`
    `ImmediateResponseExchangeHandler(int status, String message)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()` Returns the number of bytes immediately available for output.
    `void` | `consume(ByteBuffer src)` Triggered to pass incoming data to the data consumer.
    `void` | `failed(Exception cause)` Triggered to signal a failure in data processing.
    `void` | `handleRequest(HttpRequest request, EntityDetails entityDetails, ResponseChannel responseChannel, HttpContext context)` Processes the actual HTTP request.
    `void` | `produce(DataStreamChannel channel)` Triggered to signal the ability of the underlying data channel to accept more data.
    `void` | `releaseResources()`
    `void` | `streamEnd(List<? extends Header> trailers)` Triggered to signal termination of the data stream.
    `void` | `updateCapacity(CapacityChannel capacityChannel)` Triggered to signal ability of the underlying data stream to receive data capacity update.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ImmediateResponseExchangeHandler

          public ImmediateResponseExchangeHandler(AsyncResponseProducer responseProducer)

    - #### ImmediateResponseExchangeHandler

          public ImmediateResponseExchangeHandler(HttpResponse response,
                                                  String message)

    - #### ImmediateResponseExchangeHandler

          public ImmediateResponseExchangeHandler(int status,
                                                  String message)

  - ### Method Detail

    - #### handleRequest

          public void handleRequest(HttpRequest request,
                                    EntityDetails entityDetails,
                                    ResponseChannel responseChannel,
                                    HttpContext context)
                             throws HttpException,
                                    IOException

      Description copied from interface: `AsyncServerExchangeHandler`
      Processes the actual HTTP request. The handler can choose to send response messages immediately inside the call or asynchronously at some later point.
      Specified by:
        `handleRequest` in interface `AsyncServerExchangeHandler`
      Parameters:
        `request` - the actual request.
        `entityDetails` - the request entity details or `null` if the request does not enclose an entity.
        `responseChannel` - the response channel.
        `context` - the actual execution context.
      Throws:
        `HttpException` - in case of an HTTP protocol violation.
        `IOException` - in case of an I/O error.

    - #### updateCapacity

          public void updateCapacity(CapacityChannel capacityChannel)
                              throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal ability of the underlying data stream to receive data capacity update. The data consumer can choose to write data immediately inside the call or asynchronously at some later point.
      Specified by:
        `updateCapacity` in interface `AsyncDataConsumer`
      Parameters:
        `capacityChannel` - the channel for capacity updates.
      Throws:
        `IOException` - in case of an I/O error.

    - #### consume

          public void consume(ByteBuffer src)
                       throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to pass incoming data to the data consumer. The consumer must consume the entire content of the data buffer. The consumer must stop incrementing its capacity on the capacity channel if it is unable to accept more data. Once the data consumer has handled accumulated data or allocated more intermediate storage it can update its capacity information on the capacity channel.
      Specified by:
        `consume` in interface `AsyncDataConsumer`
      Parameters:
        `src` - data source.
      Throws:
        `IOException` - in case of an I/O error.

    - #### streamEnd

          public void streamEnd(List<? extends Header> trailers)
                         throws HttpException,
                                IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal termination of the data stream.
      Specified by:
        `streamEnd` in interface `AsyncDataConsumer`
      Parameters:
        `trailers` - data stream trailers.
      Throws:
        `HttpException` - in case of an HTTP protocol violation.
        `IOException` - in case of an I/O error.

    - #### available

          public int available()

      Description copied from interface: `AsyncDataProducer`
      Returns the number of bytes immediately available for output. This method can be used as a hint to control output events of the underlying I/O session.

      Please note this method should return zero if the data producer is unable to produce any more data, in which case `AsyncDataProducer.produce(DataStreamChannel)` method will not get triggered. The producer can resume writing out data asynchronously once more data becomes available or request output readiness events with `DataStreamChannel.requestOutput()`.

      Specified by:
        `available` in interface `AsyncDataProducer`
      Returns:
        the number of bytes immediately available for output
      See Also:
        `AsyncDataProducer.produce(DataStreamChannel)`, `DataStreamChannel.requestOutput()`

    - #### produce

          public void produce(DataStreamChannel channel)
                       throws IOException

      Description copied from interface: `AsyncDataProducer`
      Triggered to signal the ability of the underlying data channel to accept more data. The data producer can choose to write data immediately inside the call or asynchronously at some later point.

      Please note this method gets triggered only if `AsyncDataProducer.available()` returns a positive value.

      Specified by:
        `produce` in interface `AsyncDataProducer`
      Parameters:
        `channel` - the data channel capable of accepting more data.
      Throws:
        `IOException` - in case of an I/O error.
      See Also:
        `AsyncDataProducer.available()`

    - #### failed

          public void failed(Exception cause)

      Description copied from interface: `AsyncDataExchangeHandler`
      Triggered to signal a failure in data processing.
      Specified by:
        `failed` in interface `AsyncDataExchangeHandler`
      Parameters:
        `cause` - the cause of the failure.

    - #### releaseResources

          public void releaseResources()

      Specified by:
        `releaseResources` in interface `ResourceHolder`

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.